use regex::Regex;

pub struct LoginAttempt {
    pub ip: String,
    pub user: String,
    pub port: String,
}

impl LoginAttempt {
    pub fn new(ip: &str, user: &str, port: &str) -> Self {
        Self {
            ip: ip.to_string(),
            user: user.to_string(),
            port: port.to_string(),
        }
    }

    pub fn capture(line: &str) -> Option<Self> {
        let regex = Regex::new(r#"Failed password for (?:invalid user )?(?P<user>\S+) from (?P<ip>\S+) port (?P<port>\d+)"#).unwrap();
        let captured = regex.captures(line)?;
        Some(Self::new(
            captured.name("ip").unwrap().as_str(),
            captured.name("user").unwrap().as_str(),
            captured.name("port").unwrap().as_str(),
        ))
    }
}
